// Code generated by protoc-gen-go. DO NOT EDIT.
// source: ProtobufRpcEngine.proto

package hadoop_common

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// *
// This message is the header for the Protobuf Rpc Engine
// when sending a RPC request from  RPC client to the RPC server.
// The actual request (serialized as protobuf) follows this request.
//
// No special header is needed for the Rpc Response for Protobuf Rpc Engine.
// The normal RPC response header (see RpcHeader.proto) are sufficient.
type RequestHeaderProto struct {
	// * Name of the RPC method
	MethodName *string `protobuf:"bytes,1,req,name=methodName" json:"methodName,omitempty"`
	// *
	// RPCs for a particular interface (ie protocol) are done using a
	// IPC connection that is setup using rpcProxy.
	// The rpcProxy's has a declared protocol name that is
	// sent form client to server at connection time.
	//
	// Each Rpc call also sends a protocol name
	// (called declaringClassprotocolName). This name is usually the same
	// as the connection protocol name except in some cases.
	// For example metaProtocols such ProtocolInfoProto which get metainfo
	// about the protocol reuse the connection but need to indicate that
	// the actual protocol is different (i.e. the protocol is
	// ProtocolInfoProto) since they reuse the connection; in this case
	// the declaringClassProtocolName field is set to the ProtocolInfoProto
	DeclaringClassProtocolName *string `protobuf:"bytes,2,req,name=declaringClassProtocolName" json:"declaringClassProtocolName,omitempty"`
	// * protocol version of class declaring the called method
	ClientProtocolVersion *uint64 `protobuf:"varint,3,req,name=clientProtocolVersion" json:"clientProtocolVersion,omitempty"`
	XXX_unrecognized      []byte  `json:"-"`
}

func (m *RequestHeaderProto) Reset()                    { *m = RequestHeaderProto{} }
func (m *RequestHeaderProto) String() string            { return proto.CompactTextString(m) }
func (*RequestHeaderProto) ProtoMessage()               {}
func (*RequestHeaderProto) Descriptor() ([]byte, []int) { return fileDescriptor8, []int{0} }

func (m *RequestHeaderProto) GetMethodName() string {
	if m != nil && m.MethodName != nil {
		return *m.MethodName
	}
	return ""
}

func (m *RequestHeaderProto) GetDeclaringClassProtocolName() string {
	if m != nil && m.DeclaringClassProtocolName != nil {
		return *m.DeclaringClassProtocolName
	}
	return ""
}

func (m *RequestHeaderProto) GetClientProtocolVersion() uint64 {
	if m != nil && m.ClientProtocolVersion != nil {
		return *m.ClientProtocolVersion
	}
	return 0
}

func init() {
	proto.RegisterType((*RequestHeaderProto)(nil), "hadoop.common.RequestHeaderProto")
}

func init() { proto.RegisterFile("ProtobufRpcEngine.proto", fileDescriptor8) }

var fileDescriptor8 = []byte{
	// 197 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x7c, 0x8f, 0xb1, 0x6a, 0xc3, 0x30,
	0x14, 0x45, 0x91, 0xdb, 0xa5, 0x82, 0x2e, 0x82, 0x52, 0xd3, 0xc1, 0x98, 0x4e, 0x9e, 0x34, 0x75,
	0x2c, 0x1d, 0x5c, 0x0a, 0x9d, 0x42, 0xd0, 0x90, 0x5d, 0x96, 0x9e, 0x6d, 0x81, 0xa4, 0xa7, 0x48,
	0xf2, 0xff, 0x64, 0xce, 0x57, 0x86, 0x28, 0x09, 0x04, 0x12, 0xb2, 0x9e, 0x7b, 0xee, 0x70, 0xe8,
	0xfb, 0x3a, 0x62, 0xc6, 0x61, 0x19, 0x45, 0x50, 0x7f, 0x7e, 0x32, 0x1e, 0x78, 0x38, 0x12, 0xf6,
	0x3a, 0x4b, 0x8d, 0x18, 0xb8, 0x42, 0xe7, 0xd0, 0x7f, 0xee, 0x09, 0x65, 0x02, 0xb6, 0x0b, 0xa4,
	0xfc, 0x0f, 0x52, 0x43, 0x2c, 0x3f, 0xd6, 0x50, 0xea, 0x20, 0xcf, 0xa8, 0x57, 0xd2, 0x41, 0x4d,
	0xda, 0xaa, 0x7b, 0x11, 0x57, 0x84, 0xfd, 0xd0, 0x0f, 0x0d, 0xca, 0xca, 0x68, 0xfc, 0xf4, 0x6b,
	0x65, 0x4a, 0xe5, 0xa6, 0xd0, 0x16, 0xbf, 0x2a, 0xfe, 0x03, 0x83, 0x7d, 0xd1, 0x37, 0x65, 0x0d,
	0xf8, 0x7c, 0xa1, 0x1b, 0x88, 0xc9, 0xa0, 0xaf, 0x9f, 0xda, 0xaa, 0x7b, 0x16, 0xf7, 0xc7, 0xfe,
	0x9b, 0x36, 0x18, 0x27, 0x2e, 0x83, 0x54, 0x33, 0xf0, 0x73, 0x88, 0x09, 0xea, 0x94, 0x36, 0x2c,
	0x63, 0x7f, 0x9b, 0x5d, 0x40, 0xda, 0x11, 0x72, 0x08, 0x00, 0x00, 0xff, 0xff, 0xd8, 0xe2, 0xf0,
	0x01, 0x13, 0x01, 0x00, 0x00,
}
